use std :: ffi :: * ;
use std :: fmt :: * ;



macro_rules ! concat_os_str { (
	$ base : expr ,
	$ ( $ suffix : expr ) , +
) => { {
	let mut base = std :: ffi :: OsString :: from ( $ base ) ;
	$ ( base . push ( $ suffix ) ; ) +
	base
} } }

pub fn leak < 'l , Type > ( inner : Type ) -> & 'l Type {
	Box :: leak ( Box :: new (inner) )
}

pub fn leak_mut < 'l , Type > ( inner : Type ) -> & 'l mut Type {
	Box :: leak ( Box :: new (inner) )
}

macro_rules ! pinned_async { (
	$ ( $ async_expression : expr ) ; +
) => {
	Box :: pin ( async {
		$ ( $ async_expression ) ; +
	} )
} }

pub fn to_os_string ( value : impl Display + Sized ) -> OsString {
	OsString :: from ( ToString :: to_string ( & value ) )
}



pub (crate) use concat_os_str ;
pub (crate) use pinned_async ;
